with Ada.Calendar;
use  Ada.Calendar;

separate (Mondrian)
procedure Kopf is

  --====================================================================
  -- Autor     Christoph Grein
  -- Version   1.1
  -- Datum     8 Mai 2023
  --====================================================================
  -- Generiert die ersten Zeilen der Spezifikation und des Rumpfes des
  -- Pakets Ampel.Kreuzung.
  --====================================================================
  -- Geschichte
  -- Autor  Version  Datum    Grund der nderung
  --  C.G.    1.1  08.05.2023 berprfung auf Aktualitt
  --  C.G.    1.0  13.04.2023 Erzeugt r Ada-Tasking-Kurs
  --====================================================================

  Jetzt: constant Ada.Calendar.Time := Clock;

  Tag  : constant String := Day   (Jetzt)'Image;
  Monat: constant String := Month (Jetzt)'Image;
  Jahr : constant String := Year  (Jetzt)'Image;

begin

  Put_Line (Spez, "package " & Ada_Name & " is");
  New_Line (Spez);
  Put_Line (Spez,"  -- Erzeugt aus der Datei " & CSV_Name & " am" &
            Tag & '.' & Monat (2 .. Monat'Last) & '.' & Jahr (2 .. Jahr'Last) & '.');
  New_Line (Spez);

  Put_Line (Rumpf, "package body " & Ada_Name & " is");
  New_Line (Rumpf);
  Put_Line (Rumpf,"  -- Erzeugt aus der Datei " & CSV_Name & " am" &
            Tag & '.' & Monat (2 .. Monat'Last) & '.' & Jahr (2 .. Jahr'Last) & '.');
  New_Line (Rumpf);

end Kopf;
