separate (Mondrian)
procedure Schaltplan (Anzahl_Phasen: in Positive) is

  --====================================================================
  -- Autor     Christoph Grein
  -- Version   1.2
  -- Datum     19 April 2023
  --====================================================================
  -- Generiert den Schaltplan.
  --====================================================================
  -- Geschichte
  -- Autor  Version  Datum    Grund der nderung
  --  C.G.    1.2  19.04.2023 Farben Gelb_Dunkel und Dunkel hinzugefgt
  --  C.G.    1.1  17.04.2023 Dauer als Positive (war Duration)
  --  C.G.    1.0  13.04.2023 Erzeugt r Ada-Tasking-Kurs
  --====================================================================

begin

  Put_Line (Rumpf, "  type Zyklusfarbe is array (Ampelspur) of Ampelfarbe;");

  New_Line (Rumpf);

  Put_Line (Rumpf, "  type Ampelphase is record");
  Put_Line (Rumpf, "    Dauer: Positive;");
  Put_Line (Rumpf, "    Farbe: Zyklusfarbe;");
  Put_Line (Rumpf, "  end record;");

  New_Line (Rumpf);

  Put_Line (Rumpf, "  type Ampelschaltplan is array (Ampelzyklus) of Ampelphase;");

  New_Line (Rumpf);

  declare
    Zeile: constant String := Get_Line;  -- berspringe erste Zeile
  begin
    null;
  end;

  Put_Line (Rumpf, "  Schaltplan: constant Ampelschaltplan :=");

  Lies_Ampelschaltplan:
  declare
    Folgender: Boolean  := False;  -- Sonderbehandlung fr ersten Zyklus
  begin
    Zeilen:
    for Z in 0 .. Anzahl_Phasen - 1 loop
      declare
        Zeile : constant String := Get_Line;
        Anfang: Positive := Strichpunkt (Zeile);  -- berspringe t
        Ende  : Positive := Strichpunkt (Zeile (Anfang+1 .. Zeile'Last));
      begin
        Put (Rumpf, "    " & (if Folgender then " " else "(") & Z'Image & " => (Dauer => " & Zeile (Anfang+1 .. Ende-1) & ", Farbe => (");
        Anfang := Ende + 1;
        declare
          Folgende: Boolean := False;  -- Sonderbehandlung fr erste Farbe
        begin
          Farben:
          while Anfang < Zeile'Last loop
            Put (Rumpf, (if Folgende then ", " else ""));
            case Zeile (Anfang) is
              when 'r' => if Anfang + 2 <= Zeile'Last and then Zeile (Anfang + 2) = 'y' then  -- r;y;x  vier weiter
                            Put (Rumpf, "Rot_Gelb");
                            Anfang := Anfang + 1;
                          else
                            Put (Rumpf, "Rot");  -- r;;x  drei weiter
                          end if;
              when 'y' => if Anfang + 2 <= Zeile'Last and then Zeile (Anfang + 2) = 'd' then  -- y;d;x  vier weiter
                            Put (Rumpf, "Gelb_Dunkel");
                            Anfang := Anfang + 1;
                          else
                            Put (Rumpf, "Gelb");  -- y;;x  drei weiter
                          end if;
              when 'g' => Put (Rumpf, "Grn");
              when 'd' => Put (Rumpf, "Dunkel");
              when others => raise Program_Error with "Falsche Farbe im Schaltplan";
            end case;
            Anfang   := Anfang + 3;
            Folgende := True;
          end loop Farben;
        end;
        Put_Line (Rumpf, ")" & (if Z < Anzahl_Phasen - 1 then ")," else "));"));  -- Farbenzeile zuende
      end;
      Folgender := True;
    end loop Zeilen;
    New_Line (Rumpf);
  end Lies_Ampelschaltplan;

end Schaltplan;
