with Ada.Text_IO;
use  Ada.Text_IO;

package body Ampel.Anzeige is

  --====================================================================
  -- Autor     Christoph Grein
  -- Version   1.0
  -- Datum     19 April 2023
  --====================================================================
  --
  --====================================================================
  -- Geschichte
  -- Autor  Version  Datum    Grund der nderung
  --  C.G.    1.0  19.04.2023 Erzeugt fr Ada-Tasking-Kurs
  --====================================================================

  -- Vier Zeichen pro Spur mal Anzahl der Spuren:
  Lnge: constant := 4 * (Ampelspur'Pos (Ampelspur'Last) + 1);
  Zeile: String (1 .. Lnge);

  Gefllt: array (Ampelspur) of Boolean := (others =>  False);

  function Anfang (Spur: Ampelspur) return Positive is (4 * Ampelspur'Pos (Spur) + 1);

  procedure Set_Ampel (Spur: Ampelspur; Rot, Gelb, Grn: Boolean := False) is

  begin

    if Rot then
      if Gelb then
        Zeile (Anfang (Spur) .. Anfang (Spur) + 3) := " ry ";  -- Rot_Gelb
      else
        Zeile (Anfang (Spur) .. Anfang (Spur) + 3) := " r  ";  -- Rot
      end if;
    elsif Gelb then
      Zeile (Anfang (Spur) .. Anfang (Spur) + 3) := " y  ";    -- Gelb
    elsif Grn then
      Zeile (Anfang (Spur) .. Anfang (Spur) + 3) := " g  ";    -- Grn
    else
      Zeile (Anfang (Spur) .. Anfang (Spur) + 3) := " -- ";    -- Dunkel
    end if;

    Gefllt (Spur) := True;

    if Gefllt = (Ampelspur => True) then
      Put_Line (Zeile);
      Gefllt := (others => False);
    end if;

  end Set_Ampel;

end Ampel.Anzeige;
