with JEWL.Windows;

package body Ampel.Kontroll_Panel is

  --====================================================================
  -- Autor     Christoph Grein
  -- Version   1.0
  -- Datum     17 April 2023
  --====================================================================
  -- Darstellung des Bedienpanels und Bedienanleitung.
  --====================================================================
  -- Geschichte
  -- Autor  Version  Datum    Grund der nderung
  --  C.G.    1.0  17.04.2023 Erzeugt fr Ada-Tasking-Kurs
  --====================================================================

  package Ampel_Fenster is new JEWL.Windows (Panel_Kommando);
  use Ampel_Fenster;

  Panel_Fenster: Frame_Type  := Frame  (Title => "Ampel Kontrollpanel",                Width => 350, Height => 260,                 Command => Ende);
  Panel_Label  : Label_Type  := Label  (Panel_Fenster, Origin => (X =>  10, Y =>  10), Width => 310, Height => 220, Text => "    ");
  Ein_Knopf    : Button_Type := Button (Panel_Fenster, Origin => (X =>  60, Y => 160), Width =>  50, Height =>  25, Text => "  ? ", Command => Ein);
  Aus_Knopf    : Button_Type := Button (Panel_Fenster, Origin => (X => 180, Y => 160), Width =>  50, Height =>  25, Text => " Aus", Command => Aus);
  OK_Knopf     : Button_Type := Button (Panel_Fenster, Origin => (X => 120, Y => 160), Width =>  50, Height =>  25, Text => " OK ", Command => OK );

  function Nchstes_Kommand return Panel_Kommando renames Next_Command;

  procedure Schreib (Begrung: in String) is
  begin
    Set_Text (Panel_Label, Begrung);
  end Schreib;

  procedure Notbehelf is
    -- Die Knpfe werden nicht richtig angezeigt (wer wei, warum). Dies hilft!
  begin
    Set_Size (Panel_Fenster, Ampel_Fenster.Get_Width (Panel_Fenster) + 1, Ampel_Fenster.Get_Height (Panel_Fenster) + 1);
    delay 0.1;
    Set_Size (Panel_Fenster, Ampel_Fenster.Get_Width (Panel_Fenster) - 1, Ampel_Fenster.Get_Height (Panel_Fenster) - 1);
  end Notbehelf;

  procedure Bedienpanel_Einschalten is
  begin
    Show (OK_Knopf , Visible => False);
    Show (Ein_Knopf, Visible => True );
    Show (Aus_Knopf, Visible => True );
    Notbehelf;
  end Bedienpanel_Einschalten;

  procedure Beschriftung_Aus_Zustand (Panel_Text, Knopf_Titel: in String) is
  begin
    Set_Text (Panel_Label, Panel_Text );
    Set_Text (Ein_Knopf  , Knopf_Titel);
    Enable   (Aus_Knopf  , Enabled => False);
    Notbehelf;
  end Beschriftung_Aus_Zustand;

  procedure Beschriftung_Blinkend (Panel_Text, Knopf_Titel: in String) is
  begin
    Set_Text (Panel_Label, Panel_Text );
    Set_Text (Ein_Knopf  , Knopf_Titel);
    Enable   (Aus_Knopf  , Enabled => True);
    Notbehelf;
  end Beschriftung_Blinkend;

  procedure Beschriftung_Rot_Zustand (Panel_Text, Knopf_Titel: in String) is
  begin
    Set_Text (Panel_Label, Panel_Text );
    Set_Text (Ein_Knopf  , Knopf_Titel);
    Notbehelf;
  end Beschriftung_Rot_Zustand;

  procedure Beschriftung_Normal (Panel_Text, Knopf_Titel: in String) is
  begin
    Set_Text (Panel_Label, Panel_Text );
    Set_Text (Ein_Knopf  , Knopf_Titel);
    Notbehelf;
  end Beschriftung_Normal;

begin

  Show (Ein_Knopf , Visible => False);  -- werden nach der
  Show (Aus_Knopf , Visible => False);  -- Begrung sichtbar
  Notbehelf;

end Ampel.Kontroll_Panel;
