generic

  type Ampelspur   is    (<>);
  type Ampelzyklus is mod <>;

  with function Dauer (Zyklus: Ampelzyklus) return Positive;
  with function Farbe (Zyklus: Ampelzyklus; Spur: Ampelspur) return Ampelfarbe;

  with procedure Set_Ampel (Spur: Ampelspur; Rot, Gelb, Grn: Boolean := False) is null;

package Ampel.Steuerung is

  --====================================================================
  -- Autor     Christoph Grein
  -- Version   1.1
  -- Datum     17 April 2023
  --====================================================================
  -- Steuerung der Ampel:
  -- Zu Beginn ist die Ampel aus. Es herrscht Chaos an der vielbefah-
  -- renen Kreuzung.
  -- Die Ampel wird von einem Polizisten in Betrieb genommen ber den
  -- Eingang Ein. Der Eingang leitet von Schritt zu Schritt bis zum
  -- Errichen des automatischen Zyklus.
  -- Der Eingang Aus schaltet die Ampel wieder aus.
  -- Der Eingang Ende beendet den Prozess.
  --====================================================================
  -- Geschichte
  -- Autor  Version  Datum    Grund der nderung
  --  C.G.    1.1  17.04.2023 Dauer als Positive (war Duration)
  --  C.G.    1.0  16.04.2023 Kontrollpanel implementiert
  --  C.G.    0.0  13.04.2023 Erzeugt fr Ada-Tasking-Kurs
  --                          Kontrollpanel fehlt noch
  --====================================================================

  type Prozessorzustand is (Aus, Blinkend, Rot, Normal);

  function Ampelzustand return Prozessorzustand;

  task Prozessor is
    entry Ein;   -- einschalten
    entry Aus;   -- ausschalten
    entry Ende;  -- beenden
  end Prozessor;

end Ampel.Steuerung;
