with Ada.Characters.Latin_1;

with Ampel.Kontroll_Panel, Ampel.Instanz;
use  Ampel.Kontroll_Panel, Ampel.Instanz;

procedure Polizist is

  --====================================================================
  -- Autor     Christoph Grein
  -- Version   1.0
  -- Datum     17 April 2023
  --====================================================================
  -- Der bedienende Polizist wird durch die Einschaltsequenz gefhrt.
  --====================================================================
  -- Geschichte
  -- Autor  Version  Datum    Grund der nderung
  --  C.G.    1.0  17.04.2023 Erzeugt fr Ada-Tasking-Kurs
  --====================================================================

  function LF return Character is (Ada.Characters.Latin_1.LF);

  Begrung: constant String := "Sie sind der Polizist, der die Ampel einschaltet." & LF & LF &
                                "Vermutlich herrscht Chaos auf der vielbefahrenen Kreuzung mit " &
                                "Staus auf den wartepflichtigen Spuren.";
  Start    : constant String := "Die Ampel ist aus." & LF & LF &
                                "Drcken Sie ""Blink"", um den Einschaltvorgang mit Blinklicht " &
                                "zu starten.";
  Blinken  : constant String := "Die Ampel blinkt jetzt." & LF & LF &
                                "Warten Sie, bis sich die Verkehrsteilnehmer auf die vernderte " &
                                "Situation eingestellt haben." & LF &
                                "Dann drcken Sie ""Rot"" und warten Sie, bis die Kreuzung gerumt " &
                                "ist." & LF &
                                "Bei auftretenden Problemen mit der Ampel knnen Sie sie jederzeit " &
                                "auch wieder ausschalten.";
  Rumen   : constant String := "Die Ampel zeigt jetzt kurzzeitig ""Gelb"" (ohne blinken), dann " &
                                "schaltet sie alle Spuren auf ""Rot""." & LF & LF &
                                "Warten Sie, bis die Kreuzung gerumt ist." & LF &
                                "Dann drcken Sie ""Auto"".";
  Zyklisch : constant String := "Die Ampel luft jetzt wieder automatisch." & LF & LF &
                                "Sie knnen jederzeit wieder ""Blink"" drcken, um zu diesem " &
                                "Zustand zurckzukehren; oder Sie knnen die Ampel auch ausschalten." & LF &
                                "Wenn auf diese Kommandos binnen 1,5 s keine Reaktion erfolgt, " &
                                "ist ein Fehler aufgetreten und die Ampel muss repariert werden.";
begin

  Schreib (Begrung);

  case Nchstes_Kommand is
    when OK     => null;            -- Besttigung der Begrung
    when Ende   => Prozessor.Ende;  -- Programmende
                   return;
    when others => null;            -- hier nicht erreichbar
  end case;

  Bedienpanel_Einschalten;

  loop

    case Ampelzustand is
      when Aus      => Beschriftung_Aus_Zustand (Panel_Text => Start   , Knopf_Titel => "Blink");
      when Blinkend => Beschriftung_Blinkend    (Panel_Text => Blinken , Knopf_Titel => " Rot ");
      when Rot      => Beschriftung_Rot_Zustand (Panel_Text => Rumen  , Knopf_Titel => " Auto");
      when Normal   => Beschriftung_Normal      (Panel_Text => Zyklisch, Knopf_Titel => "Blink");
    end case;

    case Nchstes_Kommand is
      when OK   => null;            -- hier nicht mehr erreichbar
      when Ein  => Prozessor.Ein;   -- Umschalten des Ampelzustands
      when Aus  => Prozessor.Aus;   -- Ausschalen der Ampel
      when Ende => Prozessor.Ende;  -- Programmende
                   exit;
    end case;

  end loop;

end Polizist;
