with Fahrkartenautomat, Waehrung;
use  Fahrkartenautomat, Waehrung;

with Ada.Text_IO;
use  Ada.Text_IO;

procedure Kunde_Abort_Task is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      20 April 2014
  --====================================================================
  -- Demonstration einer lokal definerten Task mit Beendigung durch
  -- Abort.
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.0  20.04.2014 Created for Ada tasking course
  --====================================================================

  Line: String (1 .. 20);
  Last: Natural;

  procedure Ausgabe_abwarten is
    task Bezahlen;
    task body Bezahlen is
      Geld: Geldstueck;
      Erg : Boolean;
    begin
      loop
        <<anderes_Stueck>>
        Put ("Bezahlen: > ");
        -- Problem hier:
         -- Wie beenden wir die offene Eingabeerwartung nach Fahrkartenausgabe
        -- oder bei automatischem Abbruch?
        Get_Line (Line, Last);
        case Integer'Value (Line (1 .. Last)) is
          when     10 => Geld := Cent_10;
          when     20 => Geld := Cent_20;
          when     50 => Geld := Cent_50;
          when   1_00 => Geld := Euro_1;
          when   2_00 => Geld := Euro_2;
          when   5_00 => Geld := Euro_5;
          when  10_00 => Geld := Euro_10;
          when      0 => Abbruch;
          when others => Put_Line ("Ungueltiges Geldstueck");
                         goto anderes_Stueck;
        end case;
        Geldeingabe (Geld, Erg);  -- Ergebnis kann hier ignoriert werden
     end loop;
    end Bezahlen;
    Mein_Geld: Stueckelung (Akzeptiertes_Geldstueck);
    Fahrkarte: Fahrkartenoption;
  begin
    Ausgabe (Mein_Geld, Fahrkarte);  -- blockiert, bis genug Geld eingeworfen ist
    Put_Line ("Fahrkarte: " & Fahrkartenoption'Image (Fahrkarte) &
              ", Rckgeld"  & Integer'Image (Betrag (Mein_Geld)));
    abort Bezahlen;
  end Ausgabe_abwarten;

begin

  loop

    Put ("Fahrkartenwahl:");
    for F in Fahrkarte loop
      Put (' ' & Fahrkarte'Image (F));
    end loop;
    Put (" > ");
    Get_Line (Line, Last);
    Waehle (Fahrkarte'Value (Line (1 .. Last)));

    Ausgabe_abwarten;

  end loop;

end Kunde_Abort_Task;
