with Fahrkartenautomat, Waehrung;
use  Fahrkartenautomat, Waehrung;

with Ada.Text_IO;
use  Ada.Text_IO;

procedure Kunde_Asynchronous_Select is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.1
  -- Date      1 February 2023
  --====================================================================
  -- Demonstration Asynchronous Communication.
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.1  01.02.2023 Exception for Kartenwahl
  --  C.G.    1.0  15.04.2014 Created for Ada tasking course
  --====================================================================

  Line: String (1 .. 20);
  Last: Natural;

  procedure Bezahlen is
    Geld: Geldstueck;
    Erg : Boolean;
  begin
    loop
      <<anderes_Stueck>>
      Put ("Bezahlen: > ");
      -- Problem hier:
      -- Wie beenden wir die offene Eingabeerwartung nach Fahrkartenausgabe
      -- oder bei automatischem Abbruch?
      Get_Line (Line, Last);
      case Integer'Value (Line (1 .. Last)) is
        when     10 => Geld := Cent_10;
        when     20 => Geld := Cent_20;
        when     50 => Geld := Cent_50;
        when   1_00 => Geld := Euro_1;
        when   2_00 => Geld := Euro_2;
        when   5_00 => Geld := Euro_5;
        when  10_00 => Geld := Euro_10;
        when      0 => Abbruch;
        when others => Put_Line ("Ungueltiges Geldstueck");
                       goto anderes_Stueck;
      end case;
      Geldeingabe (Geld, Erg);  -- Erg kann hier ignoriert werden
    end loop;
  end Bezahlen;

  task Ausgabe_abwarten is
    entry Jetzt;
  end Ausgabe_abwarten;

  task body Ausgabe_abwarten is
    Mein_Geld: Stueckelung (Akzeptiertes_Geldstueck);
    Fahrkarte: Fahrkartenoption;
--  procedure Stuecke (Von: Stueckelung) is
--  begin
--    for S in Von'Range loop
--      Put_Line (Geldstueck'Image (S) &
--                Integer   'Image (Von (S)));
--    end loop;
--  end Stuecke;
  begin
    loop
      Ausgabe (Mein_Geld, Fahrkarte);  -- blockiert, bis genug Geld eingeworfen ist
      Put_Line ("Fahrkarte: " & Fahrkartenoption'Image (Fahrkarte) &
                ", Rckgeld"  & Integer'Image (Betrag (Mein_Geld)));
      accept Jetzt;
    end loop;
  end Ausgabe_abwarten;

begin

  loop

    begin

      Put ("Fahrkartenwahl:");
      for F in Fahrkarte loop
        Put (' ' & Fahrkarte'Image (F));
      end loop;
      Put (" > ");
      Get_Line (Line, Last);
      Waehle (Fahrkarte'Value (Line (1 .. Last)));

      select
        Ausgabe_abwarten.Jetzt;
      then abort
        Bezahlen;
      end select;

    exception
      when others => Put_Line ("Ungueltige Fahrkarte");
    end;

  end loop;

end Kunde_Asynchronous_Select;
