------------------------------------------------------------------------
-- This software is provided as is in the hope that it might be found
-- useful.
-- You may use and modify it freely provided you keep this copyright
-- notice unchanged and mark modifications appropriately.
--
-- Bug reports and proposals for improvements are welcome. Please send
-- them to the eMail address below.
--
-- Christoph Karl Walter Grein
-- Hauptstr. 42
-- D-86926 Greifenberg
-- Germany
--
-- eMail: Christ-Usch.Grein@T-Online.de
--
-- Copyright (c) 2013, 2014, 2023 Christoph Karl Walter Grein
------------------------------------------------------------------------

package body Waehrung is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.1
  -- Date      20 March 2014
  --====================================================================
  --
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.1  20.03.2014 Adapted for Ada tasking course
  --  C.G.    1.0  03.10.2013 Created for Ada course
  --====================================================================

  function Stueckle (Betrag: Natural) return Stueckelung is
    Rest : Natural := Betrag;
    Zwerg: Stueckelung (Geldstueck);
  begin
    -- Rckwrtsschleife ber alle Geldstcke S:
    --   Die Anzahl der Stcke S ist die
    --   Ganzzahldivision des Rests durch den
    --   Wert des Stcks S.
    --   Der neue Rest ist der Rest modulo dem
    --   Wert des Stcks S.
    for S in reverse Geldstueck loop
      Zwerg (S) := Rest  /  Wert (S);
      Rest      := Rest rem Wert (S);
    end loop;
    return Zwerg;
  end Stueckle;

  function Betrag (Stuecke: Stueckelung) return Natural is
    Zwerg: Natural := 0;
  begin
    for S in Stuecke'Range loop
      Zwerg := Zwerg + Stuecke (S) * Wert (S);
    end loop;
    return Zwerg;
  end Betrag;

end Waehrung;
