------------------------------------------------------------------------
-- This software is provided as is in the hope that it might be found
-- useful.
-- You may use and modify it freely provided you keep this copyright
-- notice unchanged and mark modifications appropriately.
--
-- Bug reports and proposals for improvements are welcome. Please send
-- them to the eMail address below.
--
-- Christoph Karl Walter Grein
-- Hauptstr. 42
-- D-86926 Greifenberg
-- Germany
--
-- eMail: Christ-Usch.Grein@T-Online.de
--
-- Copyright (c) 2013, 2014, 2023 Christoph Karl Walter Grein
------------------------------------------------------------------------

package Waehrung is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.1
  -- Date      20 March 2014
  --====================================================================
  -- Paket zur Euro-Geldstckverwaltung:
  -- Ein eigegebener Betrag kann in Mnzen und Scheine zerlegt werden
  -- (in die minimal erforderliche Anzahl), und der Betrag des Inhalts
  -- einer Brse aus Mnzen und Scheinen kann ausgegeben werden.
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.1  20.03.2014 Adapted for Ada tasking course
  --  C.G.    1.0  01.10.2013 Created for Ada course
  --====================================================================

  type Geldstueck is
    (Cent_1, Cent_2, Cent_5, Cent_10, Cent_20, Cent_50,
     Euro_1, Euro_2, Euro_5, Euro_10, Euro_20, Euro_50, Euro_100, Euro_200, Euro_500);
  subtype Muenze is Geldstueck range Cent_1 .. Euro_2;
  subtype Schein is Geldstueck range Euro_5 .. Euro_500;

  type Stueckelung is array (Geldstueck range <>) of Natural;

  Wert: constant array (Geldstueck) of Positive :=
    (Cent_1   =>      1,
     Cent_2   =>      2,
     Cent_5   =>      5,
     Cent_10  =>     10,
     Cent_20  =>     20,
     Cent_50  =>     50,
     Euro_1   =>   1_00,
     Euro_2   =>   2_00,
     Euro_5   =>   5_00,
     Euro_10  =>  10_00,
     Euro_20  =>  20_00,
     Euro_50  =>  50_00,
     Euro_100 => 100_00,
     Euro_200 => 200_00,
     Euro_500 => 500_00);

  function Stueckle (Betrag : Natural    ) return Stueckelung;
  function Betrag   (Stuecke: Stueckelung) return Natural;

end Waehrung;
