------------------------------------------------------------------------
-- This software is provided as is in the hope that it might be found
-- useful.
-- You may use and modify it freely provided you keep this copyright
-- notice unchanged and mark modifications appropriately.
--
-- Bug reports and proposals for improvements are welcome. Please send
-- them to the eMail address below.
--
-- Christoph Karl Walter Grein
-- Hauptstr. 42
-- D-86926 Greifenberg
-- Germany
--
-- eMail: Christ-Usch.Grein@T-Online.de
--
-- Copyright (c) 2022 Christoph Karl Walter Grein
------------------------------------------------------------------------

with Ada.Text_IO;

with Monte_Carlo;
with Flughafen;

package body Fluggast is

  --====================================================================
  -- Autor     Christoph Grein
  -- Version   1.0
  -- Datum     29 December 2022
  --====================================================================
  -- Der Fluggast stellt sich in der groen Wartechlange an und erhlt
  -- dort die Identitt des nchsten freien Schalters, zu dem er dann
  -- weitergeht und sofort abgefertigt wird (nach Konstruktion kann es
  -- keine Warteschlange vor dem Schalter geben).
  --====================================================================
  -- Geschichte
  -- Autor  Version   Datum   Grund der nderung
  --  C.G.    1.0  29.12.2022 Erzeugt fr Ada-Kurs Nebenlufige Prozesse
  --====================================================================

  task body Gast is
    Wohin: Flughafen.Schalterindex;
  begin
    delay Monte_Carlo.Fluggast_Ankunft;
    Ada.Text_IO.Put_Line ("Fluggast" & Mein_Name'Image & " stellt sich an.");
    Flughafen.Warteschlange.Anstellen (Mein_Name, Wohin);
    Ada.Text_IO.Put_Line ("Fluggast" & Mein_Name'Image & " geht zu Schalter" & Wohin'Image & ".");
    Flughafen.Schalterreihe (Wohin).Checkin (Mein_Name, Monte_Carlo.Gepck);
    Ada.Text_IO.Put_Line ("Fluggast" & Mein_Name'Image & " geht zur Passkontrolle.");
    -- Der Prozess endet hier.
  end Gast;

end Fluggast;
