------------------------------------------------------------------------
-- This software is provided as is in the hope that it might be found
-- useful.
-- You may use and modify it freely provided you keep this copyright
-- notice unchanged and mark modifications appropriately.
--
-- Bug reports and proposals for improvements are welcome. Please send
-- them to the eMail address below.
--
-- Christoph Karl Walter Grein
-- Hauptstr. 42
-- D-86926 Greifenberg
-- Germany
--
-- eMail: Christ-Usch.Grein@T-Online.de
--
-- Copyright (c) 2022 Christoph Karl Walter Grein
------------------------------------------------------------------------

with Ada.Numerics.Float_Random;
use  Ada.Numerics.Float_Random;

package body Monte_Carlo is

  --====================================================================
  -- Autor     Christoph Grein
  -- Version   1.0
  -- Datum     29 December 2022
  --====================================================================
  --
  --====================================================================
  -- Geschichte
  -- Autor  Version   Datum   Grund der nderung
  --  C.G.    1.0  29.12.2022 Erzeugt fr Ada-Kurs Nebenlufige Prozesse
  --====================================================================

  Generator: Ada.Numerics.Float_Random.Generator;

  -- DieSchalter ffnen innerhalb zweier Sekunden.
  function Schalterffnung return Duration is
  begin
    return Duration (2.0 * Random (Generator));
  end Schalterffnung;

  -- Die Fluggste kommen innerhalb von zehn Sekunden an.
  function Fluggast_Ankunft return Duration is
  begin
    return Duration (10.0 * Random (Generator));
  end Fluggast_Ankunft;

  -- Die Check-In-Zeit hngt vom Gepck ab.
  function Gepck return Duration is
  begin
    return 1.0 + Duration (15.0 * Random (Generator));
  end Gepck;

end Monte_Carlo;
