------------------------------------------------------------------------
-- This software is provided as is in the hope that it might be found
-- useful.
-- You may use and modify it freely provided you keep this copyright
-- notice unchanged and mark modifications appropriately.
--
-- Bug reports and proposals for improvements are welcome. Please send
-- them to the eMail address below.
--
-- Christoph Karl Walter Grein
-- Hauptstr. 42
-- D-86926 Greifenberg
-- Germany
--
-- eMail: Christ-Usch.Grein@T-Online.de
--
-- Copyright (c) 2013, 2023 Christoph Karl Walter Grein
------------------------------------------------------------------------

generic

  type Item (<>) is private;

  with procedure Callee (X: Item);

package Lock_Object is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      4 May 2013
  --====================================================================
  -- The lock object grants sequentialized calls of the Callee when
  -- called concurrently by several tasks.
  -- For instance concurrent calls to Ada.Text_IO.Put_Line by several
  -- tasks might intermingle the output. Protected objects must be used
  -- for sequentializing since Put_Line is a potentially blocking
  -- operation.
  --====================================================================
  -- History:
  -- Author Version   Date    Reason for Change
  --  C.G.   1.0  04.05.2013  Created for Ada course
  --====================================================================

  procedure Call (X: Item);

end Lock_Object;
