------------------------------------------------------------------------
-- This software is provided as is in the hope that it might be found
-- useful.
-- You may use and modify it freely provided you keep this copyright
-- notice unchanged and mark modifications appropriately.
--
-- Bug reports and proposals for improvements are welcome. Please send
-- them to the eMail address below.
--
-- Christoph Karl Walter Grein
-- Hauptstr. 42
-- D-86926 Greifenberg
-- Germany
--
-- eMail: Christ-Usch.Grein@T-Online.de
--
-- Copyright (c) 2022 Christoph Karl Walter Grein
------------------------------------------------------------------------

with Zeitstempel;

with Monte_Carlo;
with Supermarkt;
use  Supermarkt;

package body Kunden is

  --====================================================================
  -- Autor     Christoph Grein
  -- Version   1.0
  -- Datum     31 December 2022
  --====================================================================
  --
  --====================================================================
  -- Geschichte
  -- Autor  Version   Datum   Grund der nderung
  --  C.G.    1.0  31.12.2022 Erzeugt fr Ada-Kurs Nebenlufige Prozesse
  --====================================================================

  task body Kunde is
    Mein_Name: Kundenname;
  begin
    accept Start (Name: Kundenname) do
      Mein_Name := Name;
    end Start;
    delay Monte_Carlo.Kunden_Ankunft;
    Zeitstempel.Put_Line ("Kunde" & Mein_Name'Image & " kommt an.");
    declare
      --  Kasse: constant Kassenindex := Kleinste_Warteschlange;
      Kasse: constant Kassenindex := Monte_Carlo.Kassenwahl;
    begin
      Zeitstempel.Put_Line ("Kunde" & Mein_Name'Image & " stellt sich an Kasse" & Kasse'Image & " an.");
      Kassenreihe (Kasse).Bezahlen (Mein_Name, Monte_Carlo.Warenkorb);
    end;
    Zeitstempel.Put_Line ("Kunde" & Mein_Name'Image & " trgt Einkufe nach Hause.");
    -- Prozess endet hier.
  end Kunde;

end Kunden;
