------------------------------------------------------------------------
-- This software is provided as is in the hope that it might be found
-- useful.
-- You may use and modify it freely provided you keep this copyright
-- notice unchanged and mark modifications appropriately.
--
-- Bug reports and proposals for improvements are welcome. Please send
-- them to the eMail address below.
--
-- Christoph Karl Walter Grein
-- Hauptstr. 42
-- D-86926 Greifenberg
-- Germany
--
-- eMail: Christ-Usch.Grein@T-Online.de
--
-- Copyright (c) 2022 Christoph Karl Walter Grein
------------------------------------------------------------------------

with Ada.Numerics.Discrete_Random;

package body Monte_Carlo is

  --====================================================================
  -- Autor     Christoph Grein
  -- Version   1.0
  -- Datum     31 December 2022
  --====================================================================
  --
  --====================================================================
  -- Geschichte
  -- Autor  Version   Datum   Grund der nderung
  --  C.G.    1.0  31.12.2022 Erzeugt fr Ada-Kurs Nebenlufige Prozesse
  --====================================================================

  type Zeit is range 0 .. 15_000;  -- ms

  package Zeit_Random is new Ada.Numerics.Discrete_Random (Zeit);
  use Zeit_Random;

  Zeit_Generator: Zeit_Random.Generator;

  function Kunden_Ankunft return Duration is
  begin
    return Duration (Random (Zeit_Generator, First => 0_000, Last => 11_000)) / 1_000.0;
  end Kunden_Ankunft;

  -- Die Kassen-Zeit hngt vom Warenkorb ab.
  function Warenkorb return Duration is
  begin
    return Duration (Random (Zeit_Generator, First => 5_000, Last => 15_000)) / 1_000.0;
  end Warenkorb;

  package Kassen_Random is new Ada.Numerics.Discrete_Random (Supermarkt.Kassenindex);
  use Kassen_Random;

  Kassen_Generator: Kassen_Random.Generator;

  function Kassenwahl return Supermarkt.Kassenindex is
  begin
    return Random (Kassen_Generator);
  end Kassenwahl;

end Monte_Carlo;
