------------------------------------------------------------------------
-- This software is provided as is in the hope that it might be found
-- useful.
-- You may use and modify it freely provided you keep this copyright
-- notice unchanged and mark modifications appropriately.
--
-- Bug reports and proposals for improvements are welcome. Please send
-- them to the eMail address below.
--
-- Christoph Karl Walter Grein
-- Hauptstr. 42
-- D-86926 Greifenberg
-- Germany
--
-- eMail: Christ-Usch.Grein@T-Online.de
--
-- Copyright (c) 2022 Christoph Karl Walter Grein
------------------------------------------------------------------------

with Zeitstempel;

package body Supermarkt is

  --====================================================================
  -- Autor     Christoph Grein
  -- Version   1.0
  -- Datum     31 December 2022
  --====================================================================
  -- Ich habe keine Mglichkeit gefunden, die Wartechlangenlnge
  -- asychron auszuwerten; daher Gleichverteilung der Kunden auf die
  -- Kassen.
  --====================================================================
  -- Geschichte
  -- Autor  Version   Datum   Grund der nderung
  --  C.G.    1.0  31.12.2022 Erzeugt fr Ada-Kurs Nebenlufige Prozesse
  --====================================================================

  --  Warteschlangenlnge: array (Kassenindex) of Natural := (others => 0);
  --
  -- Vorsicht: Die Attribute Count knnen sich whrend der Schleife
  -- ndern; hier gibt es keine Garantie, dass das Ergebnis wirklich die
  -- krzeste Schlange ist.
  --  function Kleinste_Warteschlange return Kassenindex is
  --    Index: Kassenindex;
  --    Lnge: Natural := Natural'Last;
  --  begin
  --    for I in Kassenindex loop
  --      if Warteschlangenlnge (I) = 0 then
  --        return I;
  --      elsif Warteschlangenlnge (I) < Lnge then
  --        Lnge := Warteschlangenlnge (I);
  --        Index := I;
  --      end if;
  --    end loop;
  --    return Index;
  --  end Kleinste_Warteschlange;

  task body Kasse is
    Mein_Index: Kassenindex;
    NN: Kunden.Kundenname;
  begin
    accept Start (Index: Kassenindex) do
      Mein_Index := Index;
    end Start;
    loop
      --  Warteschlangenlnge (Mein_Index) := Bezahlen'Count;  -- see RM 9.9(7)
      --  Zeitstempel.Put_Line ("Warteschlangenlnge von" & Mein_Index'Image & " ist" & Warteschlangenlnge (Mein_Index)'Image & ".");
      accept Bezahlen (Name: Kunden.Kundenname; Warenkorb: Duration) do
        NN := Name;
        Zeitstempel.Put_Line ("Kunde" & Name'Image & " bezahlt an Kasse" & Mein_Index'Image & ".");
        delay Warenkorb;
        Zeitstempel.Put_Line ("Kunde" & Name'Image & " hat an Kasse" & Mein_Index'Image & " bezahlt.");
      end Bezahlen;
      Zeitstempel.Put_Line ("Kunde" & NN'Image & " hat Kasse" & Mein_Index'Image & " verlassen.");
    end loop;
  end Kasse;

end Supermarkt;
