------------------------------------------------------------------------
-- This software is provided as is in the hope that it might be found
-- useful.
-- You may use and modify it freely provided you keep this copyright
-- notice unchanged and mark modifications appropriately.
--
-- Bug reports and proposals for improvements are welcome. Please send
-- them to the eMail address below.
--
-- Christoph Karl Walter Grein
-- Hauptstr. 42
-- D-86926 Greifenberg
-- Germany
--
-- eMail: Christ-Usch.Grein@T-Online.de
--
-- Copyright (c) 2022 Christoph Karl Walter Grein
------------------------------------------------------------------------

with Kunden;

package Supermarkt is

  --====================================================================
  -- Autor     Christoph Grein
  -- Version   1.0
  -- Datum     31 December 2022
  --====================================================================
  -- Der Kassenprozess und die Liste der Kassen.
  -- Start gibt jeder Kasse ihren Namen.
  -- Die Dauer des Bezahlvorgangs hngt vom Warenkorb ab.
  --====================================================================
  -- Geschichte
  -- Autor  Version   Datum   Grund der nderung
  --  C.G.    1.0  31.12.2022 Erzeugt fr Ada-Kurs Nebenlufige Prozesse
  --====================================================================

  type Kassenindex is range 1 .. 5;  -- pas d'hypermarch en France

  task type Kasse is
    entry Start (Index: Kassenindex);
    entry Bezahlen (Name: Kunden.Kundenname; Warenkorb: Duration);
  end Kasse;

  Kassenreihe: array (Kassenindex) of Kasse;

  --  function Kleinste_Warteschlange return Kassenindex;

end Supermarkt;
